<template>
  <div
    v-if="getLobbyGamesByGameSelected.length"
    :class="['flex flex-col w-full game-lobby-module-4', { 'px-2': isMobile }]"
  >
    <div class="flex items-center justify-between mb-2 md:mb-4">
      <div class="text-2xl font-bold --text2 flex items-center">
        <SvgIcon
          class="w-7 h-7 !fill-[var(--primary)] mr-2"
          :class="{
            '!w-5 !h-5': isMobile,
          }"
          svg-name="icon-special-selection"
        />
        <span
          class="uppercase"
          :class="{
            'text-base': isMobile,
          }"
        >
         {{ getDisplayName(gameSelected) }}
        </span>
      </div>
      <div
        class="cursor-pointer py-2 px-3 bg-[var(--primary)] rounded-lg text-[var(--textBtn)] font-medium uppercase h-[35px] flex justify-center items-center"
        :class="{
          'pr-3 py-[7px]': isMobile,
        }"
        @click="onClickViewMore(gameSelected)"
      >
        <span
          class="text-base"
          :class="{
            'text-xs': isMobile,
          }"
        >
          {{ $t("View More") }}
        </span>
      </div>
    </div>
    <div
      class="grid items-start grid-cols-5 gap-5"
      :class="{
        '!grid-cols-3 !gap-2': isMobile,
      }"
    >
      <button
        v-for="(item, index) in getLobbyGamesByGameSelected"
        :key="index"
        class="w-full aspect-[1/1] relative rounded-lg md:rounded-2xl bg-background5 p-1.5 md:p-4"
        :class="[{ 'h-full flex flex-col': isMobile }, { group: !isMobile }]"
        @mouseenter="handleMouseEnter($event)"
        @mouseleave="handleMouseLeave($event)"
      >
        <SharedButtonFavorite
          v-if="isMobile"
          :game="item"
          class="absolute top-[10px] right-[10px]"
          button-style="two"
        />
        <IconFavoriteNew
          v-else
          class="w-full z-[11]"
          :-for-mobile="isMobile"
          :game-data="item"
          :check-is-favourite="checkIsFavourite"
          :redirect-to-login="redirectToLogin"
          :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
          :show-inactive-icon="showInactiveIcon"
          :toggle-dialog="isMobile"
        />
        <div
          class="bg-background1 rounded md:rounded-lg mb-1.5 relative overflow-hidden z-10"
          :class="{
            group: !isMobile,
          }"
          @click="
            authenticated
              ? handleGameEntryOpenWindow(item, 850, 850)
              : toggleLoginRegisterDialog()
          "
        >
          <div
            v-if="!isMobile"
            class="icon-status hot"
            :class="checkStatus(item)"
          ></div>
          <div
            v-else-if="!checkStatus(item).includes('disabled')"
            class="absolute top-1 left-1 flex flex-col gap-0.5 z-20"
          >
            <HotGame
              v-if="checkStatus(item).includes('hot')"
              class="h-[10.67px]"
            />
            <NewGame
              v-if="checkStatus(item).includes('new')"
              class="h-[10.67px]"
            />
          </div>
          <img
            v-lazy="item.GameIconUrl"
            class="w-full relative aspect-square object-cover background-image"
            :alt="item.GameName"
          />
          <div class="play__now__overlay items-center flex flex-col relative">
            <div
              class="absolute top-0 left-0 w-full h-full opacity-0 bg-[#000000] game-backdrop"
            />
            <div class="play-now-container" v-if="!isMobile">
              <div
                class="flex items-center justify-center mb-1 relative play-btn"
              >
                <SvgIcon
                  class="w-12 h-12 !fill-[var(--primary)] absolute z-10 play-icon"
                  svg-name="play-button"
                />
                <span
                  class="w-16 h-16 bg-[var(--primary)] opacity-20 rounded-full"
                ></span>
              </div>
              <div class="play__now__content_for_animate relative capitalize">
                {{ $t("play_now").toLowerCase() }}
              </div>
            </div>
          </div>
        </div>
        <div
          class="self-center text-xs p-2.5 text-[var(--text5)] font-medium"
          :class="{
            '!p-0 w-[85px] !text-[9px]': isMobile,
          }"
          style="word-break: break-word"
        >
          {{ item.GameName }}
        </div>
      </button>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useGameModule } from "@/composables/lobby/useGameModule";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import HotGame from "~/assets/icons/hot-games.svg?component";
import NewGame from "~/assets/icons/new-games.svg?component";
import { isString } from "lodash";

const props = defineProps<{
  gameSelected: string;
}>();
const {
  lobbyGames,
  selectedGameType,
  getSpecialSelectionGameListInitial,
  getGameListByGameTypeInitial,
  onClickViewMore,
  checkStatus,
  authenticated,
  isMobile,
  getHotGameListInitial,
  getNewGameListInitial,
  getDisplayName,
} = useGameModule();
const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
  useAddToFavorite("-new");
const handleMouseEnter = (event: MouseEvent) => {
  const target = event.currentTarget as HTMLElement;
  const inactiveId = target.querySelector("#inactive-favourite") as HTMLElement;
  if (inactiveId && !isMobile) {
    inactiveId.style.animation = "fadeInFromTop 0.5s ease-in-out forwards";
  }
};
const handleMouseLeave = (event: MouseEvent) => {
  const target = event.currentTarget as HTMLElement;
  const inactiveId = target.querySelector("#inactive-favourite") as HTMLElement;
  if (inactiveId && !isMobile) {
    inactiveId.style.animation = "fadeOutToTop-new 0.2s ease-in-out forwards";
  }
};
const showInactiveIcon = ref(false);
onMounted(() => {
  if (!isString(props.gameSelected) || ['Special Selection', ''].includes(props.gameSelected)) {
    getSpecialSelectionGameListInitial();
  } else if (props.gameSelected === 'Hot Games') {
    getHotGameListInitial();
  } else if (props.gameSelected === 'New Games') {
    getNewGameListInitial();
  } else {
    getGameListByGameTypeInitial();
  }
  setTimeout(() => {
    showInactiveIcon.value = true;
  }, 0);
});
const { toggleLoginRegisterDialog } = commonHelper;
const getLobbyGamesByGameSelected = computed(() => {
  if (!isString(props.gameSelected) || ['Special Selection', ''].includes(props.gameSelected)) {
    return lobbyGames.value.SpecialSelectionForDisplay;
  } else if (props.gameSelected === 'Hot Games') {
    return lobbyGames.value.HotGameForDisplay;
  } else if (props.gameSelected === 'New Games') {
    return lobbyGames.value.NewGamesForDisplay;
  } else {
    selectedGameType.value = props.gameSelected.replace(/\s/g, "");
    return lobbyGames.value.GameByType;
  }
})
</script>

<style scoped lang="scss">
.game-lobby-module-4 {
  .group {
    .game-backdrop {
      transition: opacity 300ms linear;
    }
    .play-now-container {
      pointer-events: none;
      opacity: 0;
      transition: opacity 300ms linear;
    }
    .background-image {
      transition: all 300ms linear;
    }
  }
  .group:hover {
    .background-image {
      -webkit-filter: blur(5px);
    }
    .game-backdrop {
      opacity: 0.5;
    }
    .play-now-container {
      opacity: 1;
      pointer-events: unset;
    }
  }
}
.play__now__overlay {
  @apply duration-[400ms] absolute top-0 left-0 z-10 w-full h-full flex rounded-lg justify-center;
}
.play__now__content {
  @apply flex justify-center items-center bg-green-500 text-sm font-bold text-white rounded-full h-8 w-[120px];
}
.play__now__content_for_animate {
  @apply flex justify-center items-center text-sm text-white;
}
.bg-background5 {
  background-color: var(--background5);
}
.play-icon {
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}
.group:hover .play__now__content_for_animate,
.group:hover .play-btn,
.group:hover .play__now__overlay {
  animation: 0.5s infinite alternate;
}
// .icon-status:not(.disabled)
.icon-status {
  position: absolute;
  width: 56px;
  height: 26px;
  border-top-left-radius: 8px;
  border-bottom-right-radius: 16px;
  top: 0px;
  left: 0px;
  color: var(--text5);
  text-align: center;
  font-family: "Roboto";
  font-style: normal;
  font-weight: 700;
  font-size: 16px;
  letter-spacing: 0.02em;
  z-index: 20;
  &.new {
    background-color: #2a71dc;
    &::after {
      content: "New";
      position: absolute;
      top: 2px;
      left: 14px;
    }
  }
  &.hot {
    background-color: #ff264d;
    &::after {
      content: "Hot";
      position: absolute;
      top: 2px;
      left: 14px;
    }
  }
}
@keyframes fadeOutToTop-new {
  0% {
    opacity: 1;
    transform: translateY(0);
  }
  100% {
    opacity: 0;
    transform: translateY(-120%);
  }
}
@keyframes fadeInFromTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    transform: translateY(0);
  }
}
</style>
